#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <sys/stat.h>
#include <fcntl.h>

int maxx, maxy=1;
int n=1;

#define maxskrz 15


//#define debug

typedef enum {
	GORA = 1,
	LEWO = 2,
	PRAWO = 4,
	DOL = 8
} Kierunek;

struct pozycja {
	unsigned int x;
	unsigned int y;
};

struct stan {
	struct pozycja sokoban;
	struct pozycja skrzynie[maxskrz];
};

struct kierunek {
	char k;
	struct kierunek* poprz;
};

struct ruch {
	struct pozycja sokoban;
	struct pozycja skrzynka;
	
	int n;
	int i;
	char** plansza;
	int powrot;
	struct stan sytuacja;
	
	struct ruch* nastepny;
	struct ruch* poprzedni;
	
	char kierunki[maxskrz][4];
};

char kierunki[maxskrz][4];

// stos
struct ruch* pocz=0;
struct ruch* kon=0;

struct ruch pierwszy;

// srugi stos
struct kierunek* pocz_k=0;
struct kierunek* kon_k=0;

char** plansza;
char** plansza_tmp2;
int skrzynek=0;
int docel=0;
int x, y;

int** koszty[maxskrz];

//int max=0;
struct stan nowy;
struct stan sytuacja_glob;
struct pozycja mdocel[maxskrz];
struct pozycja start;
struct stan stanpocz;
struct ruch* decyzja;

char** plansza_blok;

char** bloki;
char** poz_docelowe;
// z rekurencji
int i, j;
char** plansza_tmp;
int powrot;
struct stan sytuacja;

// deklaracje dla drzewa

typedef struct pozycja* KeyType;        

typedef struct pozycja ValType;

typedef enum {
	RBT_STATUS_OK,
	RBT_STATUS_BRAK_PAM,
	RBT_STATUS_DUP_KEY,
	RBT_STATUS_BRAK_KEY
} RbtStatus;

typedef enum { CZARN, CZERW } nodeColor;

typedef struct WezelTag {
	struct WezelTag *lewys;   
	struct WezelTag *prawys;  
	struct WezelTag *rodzic; 
	nodeColor color;
	KeyType key;            
	ValType val;            
} WezelType;

#define SENTINEL &sentinel  
static WezelType sentinel = { SENTINEL, SENTINEL, 0, CZARN, 0};

static WezelType *korzen = SENTINEL;

// porownanie stanow, zwraca:
// a < b -> -1
// a == b -> 0
// a > b -> 1
inline int comp(struct WezelTag* a, struct WezelTag* b) {
	int i;

	for (i=0; i<skrzynek; i++) {
		#ifdef debug
		printf("Porownanie skrzynek: %d %d %d %d\n", a->key[i].x, a->key[i].y, b->key[i].x, b->key[i].y);
		#endif
		if (a->key[i].x > b->key[i].x)
			return 1;
		else if (a->key[i].x < b->key[i].x)
			return -1;
		else if (a->key[i].y > b->key[i].y)
			return 1;
		else if (a->key[i].y < b->key[i].y)
			return -1;
	}
	#ifdef debug
	printf("Porownanie sokobanow: %d %d %d %d\n", a->val.x, a->val.y, b->val.x, b->val.y);
	#endif
	if (a->val.x > b->val.x)
		return 1;
	else if (a->val.x < b->val.x)
		return -1;
	else if (a->val.y > b->val.y)
		return 1;
	else if (a->val.y < b->val.y)
		return -1;

	return 0;
}

inline static void rotateLeft(WezelType *x) {
	WezelType *y = x->prawys;
	
	
	x->prawys = y->lewys;
	if (y->lewys != SENTINEL)
		y->lewys->rodzic = x;
	
	
	if (y != SENTINEL)
		y->rodzic = x->rodzic;
	if (x->rodzic) {
		if (x == x->rodzic->lewys)
		x->rodzic->lewys = y;
		else
		x->rodzic->prawys = y;
	} else
		korzen = y;
	
	y->lewys = x;
	if (x != SENTINEL)
		x->rodzic = y;
}

inline static void rotateRight(WezelType *x) {
	WezelType *y = x->lewys;


    	x->lewys = y->prawys;
    	if (y->prawys != SENTINEL)
		y->prawys->rodzic = x;


    	if (y != SENTINEL)
		y->rodzic = x->rodzic;
    	if (x->rodzic) {
        	if (x == x->rodzic->prawys)
            		x->rodzic->prawys = y;
        	else
            		x->rodzic->lewys = y;
    	} else
        	korzen = y;

    	y->prawys = x;
    	if (x != SENTINEL)
    		x->rodzic = y;
}

inline static void insertFixup(WezelType *x) {
	while (x != korzen && x->rodzic->color == CZERW) {
		if (x->rodzic == x->rodzic->rodzic->lewys) {
			WezelType *y = x->rodzic->rodzic->prawys;
			if (y->color == CZERW) {
				y->color = CZARN;
				x->rodzic->color = CZARN;
				x->rodzic->rodzic->color = CZERW;
				x = x->rodzic->rodzic;
			} else {
				if (x == x->rodzic->prawys) {
					x = x->rodzic;
					rotateLeft(x);
				}
				x->rodzic->rodzic->color = CZERW;
				x->rodzic->color = CZARN;
				rotateRight(x->rodzic->rodzic);
			}
		} else {
			WezelType *y = x->rodzic->rodzic->lewys;
			if (y->color == CZERW) {
				x->rodzic->color = CZARN;
				y->color = CZARN;
				x->rodzic->rodzic->color = CZERW;
				x = x->rodzic->rodzic;
			} else {
				if (x == x->rodzic->lewys) {
					x = x->rodzic;
					rotateRight(x);
				}
				x->rodzic->color = CZARN;
				x->rodzic->rodzic->color = CZERW;
				rotateLeft(x->rodzic->rodzic);
			}
		}
    	}
    	korzen->color = CZARN;
}


inline RbtStatus rbtInsert(KeyType key, ValType val) {
    	WezelType *current, *rodzic, *x;
    	WezelType tmp;
    	int status;

    	tmp.key = key;
    	tmp.val = val;
	
    	current = korzen;
    	rodzic = 0;
    
    	while (current != SENTINEL) {
    		status = comp(&tmp, current);
        	if (!status)
            		return RBT_STATUS_DUP_KEY;
        	rodzic = current;
		if (status==-1)
			current = current->lewys;
		else
			current = current->prawys;
		#ifdef debug
		printf("%d ", status);
		#endif
    	}
    	#ifdef debug
    	printf("\n");
    	#endif
	
    	if (!(x = malloc (sizeof(WezelType))))
        	return RBT_STATUS_BRAK_PAM;
    	x->rodzic = rodzic;
    	x->lewys = SENTINEL;
    	x->prawys = SENTINEL;
    	x->color = CZERW;
    	x->val = val;
    
    	x->key = malloc(sizeof(struct pozycja) * skrzynek);
    	memcpy(x->key, key, sizeof(struct pozycja) * skrzynek);


    	if(rodzic) {
        	if(comp(&tmp, rodzic)==-1)
            		rodzic->lewys = x;
        	else
            		rodzic->prawys = x;
    	} else
        	korzen = x;

    	insertFixup(x);

    	return RBT_STATUS_OK;
}

inline int compar(const void* a1, const void* b1) {
	struct pozycja* a = (struct pozycja*)a1;
	struct pozycja* b = (struct pozycja*)b1;

	if (a->x > b->x)
		return 1;
	else if (a->x < b->x)
		return -1;
	else if (a->y > b->y)
		return 1;
	else if (a->y < b->y)
		return -1;
	return 0;
}

inline void push_(char c) {
	struct kierunek* tmp;

	if (pocz_k==0) {
		pocz_k = kon_k = malloc(sizeof(struct kierunek));
		pocz_k->k = c;
	} else {
		tmp = kon_k;
		kon_k = malloc(sizeof(struct kierunek));
		kon_k->k = c;
		kon_k->poprz = tmp;
	}
}

inline void szukaj_drogi(int** tab, int sx, int sy, int odleglosc) {
	if (odleglosc<tab[sx][sy]) {
		tab[sx][sy]=odleglosc;
		if (tab[sx-1][sy]!=-1)
			szukaj_drogi(tab, sx-1, sy, odleglosc+1);
		if (tab[sx+1][sy]!=-1)
			szukaj_drogi(tab, sx+1, sy, odleglosc+1);
		if (tab[sx][sy-1]!=-1)
			szukaj_drogi(tab, sx, sy-1, odleglosc+1);
		if (tab[sx][sy+1]!=-1)
			szukaj_drogi(tab, sx, sy+1, odleglosc+1);
	}
}

inline void koniec_zabawy() {
	int** tablica;
	struct ruch* tmp;
	int i, x, y;
	struct kierunek* tmpk;
	#ifdef debug
	printf("Youpie K. I. A.\n");
	#endif
	tablica = malloc(maxx*sizeof(int*));
    	    
    	for (i=0; i<maxx; i++)
    		tablica[i] = malloc(maxy*sizeof(int));

	for (x=0; x<maxx; x++)
		for(y=0; y<maxy; y++)
			tablica[x][y] = plansza[x][y]==' ' ? 99999 : -1;
	
	// naniesienie skrzynek
			
	for (x=0; x<skrzynek; x++)
		tablica[stanpocz.skrzynie[x].x][stanpocz.skrzynie[x].y]=-1;
	
		
	for (;;) {
		tablica[start.x][start.y] = 1;
		szukaj_drogi(tablica, start.x, start.y, 0);
		
		//odtworzenie
		
		x = pocz->sokoban.x;
		y = pocz->sokoban.y;
		
		for (i=tablica[pocz->sokoban.x][pocz->sokoban.y]-1; i>=0; i--) {
			if (tablica[x][y+1] == i) {
				push_('U');
				y++;
			} else if (tablica[x-1][y] == i) {
				push_('R');
				x--;
			} else if (tablica[x][y-1] == i) {
				y--;
				push_('D');
			} else {
				x++;
				push_('L');
			}
		}
			
		//wypisanie
	
		if (pocz_k!=0)
			for (;;) {
				printf("%c", kon_k->k);
		
				if (kon_k == pocz_k) {
					free(pocz_k);
					kon_k = pocz_k = 0;
					break;
				}
		
				tmpk = kon_k;
				kon_k = kon_k->poprz;
				free(tmpk);
			}
		
		if ((pocz->skrzynka.x == (pocz->sokoban.x+1)) && (pocz->skrzynka.y == pocz->sokoban.y)) {
			printf("R");
			tablica[pocz->skrzynka.x+1][pocz->skrzynka.y] = -1;
		} else if ((pocz->skrzynka.x == pocz->sokoban.x) && (pocz->skrzynka.y == (pocz->sokoban.y-1))) {
			printf("U");
			tablica[pocz->skrzynka.x][pocz->skrzynka.y-1] = -1;
		} else if ((pocz->skrzynka.x == (pocz->sokoban.x-1)) && (pocz->skrzynka.y == pocz->sokoban.y)) {
			printf("L");
			tablica[pocz->skrzynka.x-1][pocz->skrzynka.y] = -1;
		} else {
			printf("D");
			tablica[pocz->skrzynka.x][pocz->skrzynka.y+1] = -1;
		}
		
		tablica[pocz->skrzynka.x][pocz->skrzynka.y] = 99999;
		
		start.x = pocz->skrzynka.x;
		start.y = pocz->skrzynka.y;
		if (pocz!=kon) {
			tmp = pocz;
			pocz = pocz->nastepny;
			free(tmp);
		} else
			break;
			
		for (x=0; x<maxx; x++)
			for(y=0; y<maxy; y++)
				if (tablica[x][y]!=-1)
					tablica[x][y] = 99999;
		
	}
	#ifdef debug
	printf("\n");
	#endif
	exit(EXIT_SUCCESS);
}

inline void wyznacz_pole_dzialania(char** plansza, int prawo, int dol, int lewo, int gora, int xi, int yi) {
	plansza[xi][yi] = '.';
	if (plansza[xi-1][yi]==' ' && lewo)
		wyznacz_pole_dzialania(plansza, 0, 1, 1, 1, xi-1, yi);
	if (plansza[xi+1][yi]==' ' && prawo)
		wyznacz_pole_dzialania(plansza, 1, 1, 0, 1, xi+1, yi);
	if (plansza[xi][yi-1]==' ' && gora)
		wyznacz_pole_dzialania(plansza, 1, 0, 1, 1, xi, yi-1);
	if (plansza[xi][yi+1]==' ' && dol)
		wyznacz_pole_dzialania(plansza, 1, 1, 1, 0, xi, yi+1);
}

inline void push(struct ruch* tmp) {
	if (!pocz)
		pocz = kon = tmp;
	else {
		kon->nastepny = tmp;
		tmp->poprzedni = kon;
		kon = tmp;
	}
	#ifdef debug
	printf("%d %d %d %d", tmp->sokoban.x, tmp->sokoban.y, tmp->skrzynka.x, tmp->skrzynka.y);
	#endif
}

inline void pop() {
	int k, l;

    	for (k=0; k<maxx; k++)
		free(plansza_tmp[k]);
	
	free(plansza_tmp);
		
	plansza_tmp = kon->plansza;
	i = kon->i;
	sytuacja = kon->sytuacja;
	j = kon->powrot;
	for (k=0; k<skrzynek; k++)
		for (l=0; l<4; l++)
			kierunki[k][l] = kon->kierunki[k][l];

	n=kon->n;
	
	if (pocz == kon) {
		free(pocz);
		kon = pocz = 0;
	} else {
		kon = kon->poprzedni;
		free(kon->nastepny);
	}
}

inline void foo() {}

inline int blok(int xi, int yi) {

	#ifdef debug
	printf("sprawdzam blok: %d %d\n", xi, yi);
	#endif

	if (plansza_blok[xi][yi]=='#' || plansza_blok[xi][yi]=='?')
		return 1;
	else if (plansza_blok[xi][yi]==' ')
		return 0;
		
	
	plansza_blok[xi][yi]='?';
	if ((blok(xi,yi-1) && blok(xi+1,yi)) || (blok(xi+1,yi) && blok(xi,yi+1)) || (blok(xi,yi+1) && blok(xi-1,yi)) || (blok(xi-1,yi) && blok(xi,yi-1)))
		return 1;
	return 0;
}

inline int rog(int xi, int yi, int oldx, int oldy) {
	int cnt, l1, l2;


	for (cnt = 0; cnt<skrzynek; cnt++)
		if (mdocel[cnt].x==xi && mdocel[cnt].y==yi)
			return 0;
	// inne mozliwosci
		
	for (l1=0; l1<maxx; l1++)
		for (l2=0; l2<maxy; l2++) {
			if (plansza_tmp[l1][l2]=='#')
				plansza_blok[l1][l2]='#';
			else if (plansza_tmp[l1][l2]=='O')
				plansza_blok[l1][l2]='O';
			else
				plansza_blok[l1][l2]=' ';
		}
	
	plansza_blok[xi][yi] = '?';
	plansza_blok[oldx][oldy] = ' ';
		
	if ((blok(xi,yi-1) && blok(xi+1,yi)) || (blok(xi+1,yi) && blok(xi,yi+1)) || (blok(xi,yi+1) && blok(xi-1,yi)) || (blok(xi-1,yi) && blok(xi,yi-1)))
		return 1;
		
	return 0;
}

void wyznacz_kierunki(struct ruch* decyzja) {
	int i, j, min;
	int tmp;
	char bylo;
	char naj;
	
	for (i=0; i<skrzynek; i++) {
		bylo = 0;
		for (j=0; j<4; j++) {
			min = 999999;
			naj = 0;
			if (!(bylo&GORA)) {
				tmp = koszty[i][decyzja->sytuacja.skrzynie[i].x][decyzja->sytuacja.skrzynie[i].y-1];
				if (tmp>=0 && tmp<min) {
					min = tmp;
					naj = GORA;
				}
			}
			if (!(bylo&DOL)) {
				tmp = koszty[i][decyzja->sytuacja.skrzynie[i].x][decyzja->sytuacja.skrzynie[i].y+1];
				if (tmp>=0 && tmp<min) {
					min = tmp;
					naj = DOL;
				}
			}
			if (!(bylo&LEWO)) {
				tmp = koszty[i][decyzja->sytuacja.skrzynie[i].x-1][decyzja->sytuacja.skrzynie[i].y];
				if (tmp>=0 && tmp<min) {
					min = tmp;
					naj = LEWO;
				}
			}
			if (!(bylo&PRAWO)) {
				tmp = koszty[i][decyzja->sytuacja.skrzynie[i].x+1][decyzja->sytuacja.skrzynie[i].y];
				if (tmp>=0 && tmp<min) {
					min = tmp;
					naj = PRAWO;
				}
			}
			bylo = bylo | naj;
			decyzja->kierunki[i][j]=naj;
			#ifdef debug
  			printf("%d\n", naj);
			#endif
		}
	}
	
	for (i=0; i<skrzynek; i++) {
		for (j=0; j<4; j++)
			kierunki[i][j] = decyzja->kierunki[i][j];
	}
}

inline void rozwiazuj() {
	int k, l;
	struct pozycja skrzynie_sort[maxskrz];
	
	#ifdef debug
	printf("proba...\n");
	#endif
	
	nowa_proba:

	plansza_tmp = 0;
    	plansza_tmp = malloc(maxx*sizeof(char*));
    
    	for (i=0; i<maxx; i++)
		plansza_tmp[i] = malloc(maxy*sizeof(char));
  
	i = 0;
	
	memcpy(skrzynie_sort, sytuacja.skrzynie, skrzynek*sizeof(struct pozycja));
	qsort(skrzynie_sort, skrzynek, sizeof(struct pozycja), compar);
	
	if (rbtInsert(skrzynie_sort, sytuacja.sokoban)!=RBT_STATUS_OK) {
		#ifdef debug
		printf("KOLIZJA!!!!\n");
		#endif
		
		pop();
		goto powrot;
	}
	
	for(y=0; y<maxy; y++) {
		for (x=0; x<maxx; x++) {
			plansza_tmp[x][y]=plansza_tmp2[x][y];
			#ifdef debug
			printf("%c", plansza_tmp[x][y]);
			#endif
		}
		#ifdef debug
		printf("\n");
		#endif
	}


	for (i=0; i<skrzynek; i++, n = (n + 1) % skrzynek) {
		j=-1;
		powrot:
		j++;
		for(; j<4; j++) {
			if (kierunki[n][j]==PRAWO && (plansza_tmp[sytuacja.skrzynie[n].x+1][sytuacja.skrzynie[n].y]==' ' || plansza_tmp[sytuacja.skrzynie[n].x+1][sytuacja.skrzynie[n].y]=='.') && plansza_tmp[sytuacja.skrzynie[n].x-1][sytuacja.skrzynie[n].y]=='.' && bloki[sytuacja.skrzynie[n].x+1][sytuacja.skrzynie[n].y]!='.' && !rog(sytuacja.skrzynie[n].x+1, sytuacja.skrzynie[n].y, sytuacja.skrzynie[n].x, sytuacja.skrzynie[n].y)) {
				// sproboj w prawo
				#ifdef debug
				printf("moze w prawo...\n");
				#endif
				
				
				
				
				decyzja = malloc(sizeof(struct ruch));
				decyzja->sokoban.x = sytuacja.skrzynie[n].x-1;
				decyzja->sokoban.y = sytuacja.skrzynie[n].y;
				decyzja->skrzynka.x = sytuacja.skrzynie[n].x;
				decyzja->skrzynka.y = sytuacja.skrzynie[n].y;
				
				
				//wyznacz sytuacje i przekaz w parametrze: 1. wyznacz pozycje sokobana, 2. wyznacz i posortuj pozycje skrzynek
				
				// wyznaczenie tymczasowej planszy dla nowego stanu
				for (x=0; x<maxx; x++)
					for(y=0; y<maxy; y++)
						plansza_tmp2[x][y]=plansza[x][y];
		
				for (x=0; x<skrzynek; x++)
					plansza_tmp2[sytuacja.skrzynie[x].x][sytuacja.skrzynie[x].y]='O';
				
					
				plansza_tmp2[decyzja->skrzynka.x+1][decyzja->skrzynka.y]='O';
				
				wyznacz_pole_dzialania(plansza_tmp2, 1, 1, 1, 1, decyzja->skrzynka.x, decyzja->skrzynka.y);
				
				// znalezienie odp pozycji sokobana do zapamietania w stanie
				
				for (x=0; x<maxx; x++)
					for(y=0; y<maxy; y++)
						if (plansza_tmp2[x][y] == '.')
							goto koniec1;
							
				koniec1:
				
				sytuacja_glob.sokoban.x = x;
				sytuacja_glob.sokoban.y = y;
				
				// pozycje skrzynek
				
				for (x=0; x<skrzynek; x++) {
					sytuacja_glob.skrzynie[x].x = sytuacja.skrzynie[x].x;
					sytuacja_glob.skrzynie[x].y = sytuacja.skrzynie[x].y;
				}
				
				sytuacja_glob.skrzynie[n].x++;
				
				// posortowanie skrzynek

				
				// wywolanie rek
				decyzja->i = i;
				decyzja->plansza = plansza_tmp;
				decyzja->powrot = j;
				decyzja->sytuacja = sytuacja;
				for (k=0; k<skrzynek; k++)
					for (l=0; l<4; l++)
						decyzja->kierunki[k][l] = kierunki[k][l];
				
				pierwszy.sytuacja = sytuacja;
				pierwszy.sytuacja.skrzynie[n].x++;
				wyznacz_kierunki(&pierwszy);
				pierwszy.sytuacja.skrzynie[n].x--;
				
				for (k=0; k<skrzynek; k++)
					for (l=0; l<4; l++)
						kierunki[k][l] = pierwszy.kierunki[k][l];
				
						
				decyzja->n=n;
				if (poz_docelowe[sytuacja.skrzynie[n].x+1][sytuacja.skrzynie[n].y]=='x')// {
					n = (n + 1) % skrzynek;

				push(decyzja);
				sytuacja = sytuacja_glob;
				
				goto nowa_proba;
			}
			if (kierunki[n][j]==DOL && (plansza_tmp[sytuacja.skrzynie[n].x][sytuacja.skrzynie[n].y+1]==' ' || plansza_tmp[sytuacja.skrzynie[n].x][sytuacja.skrzynie[n].y+1]=='.')&& plansza_tmp[sytuacja.skrzynie[n].x][sytuacja.skrzynie[n].y-1]=='.' && bloki[sytuacja.skrzynie[n].x][sytuacja.skrzynie[n].y+1]!='.' && !rog(sytuacja.skrzynie[n].x, sytuacja.skrzynie[n].y+1, sytuacja.skrzynie[n].x, sytuacja.skrzynie[n].y)) {
				// sproboj w dol
				#ifdef debug
				printf("moze w dol...\n");
				#endif
				
				
				
				decyzja = malloc(sizeof(struct ruch));
				decyzja->sokoban.x = sytuacja.skrzynie[n].x;
				decyzja->sokoban.y = sytuacja.skrzynie[n].y-1;
				decyzja->skrzynka.x = sytuacja.skrzynie[n].x;
				decyzja->skrzynka.y = sytuacja.skrzynie[n].y;
				for (x=0; x<maxx; x++)
					for(y=0; y<maxy; y++)
						plansza_tmp2[x][y]=plansza[x][y];
		
				for (x=0; x<skrzynek; x++)
					plansza_tmp2[sytuacja.skrzynie[x].x][sytuacja.skrzynie[x].y]='O';
				
					
				plansza_tmp2[decyzja->skrzynka.x][decyzja->skrzynka.y+1]='O';
				
				wyznacz_pole_dzialania(plansza_tmp2, 1, 1, 1, 1, decyzja->skrzynka.x, decyzja->skrzynka.y);
				
				// znalezienie odp pozycji sokobana do zapamietania w stanie
				
				for (x=0; x<maxx; x++)
					for(y=0; y<maxy; y++)
						if (plansza_tmp2[x][y] == '.')
							goto koniec2;
							
				koniec2:
				
				sytuacja_glob.sokoban.x = x;
				sytuacja_glob.sokoban.y = y;
				
				// pozycje skrzynek
				
				for (x=0; x<skrzynek; x++) {
					sytuacja_glob.skrzynie[x].x = sytuacja.skrzynie[x].x;
					sytuacja_glob.skrzynie[x].y = sytuacja.skrzynie[x].y;
				}
				
				sytuacja_glob.skrzynie[n].y++;
				
				decyzja->i = i;
				decyzja->plansza = plansza_tmp;
				decyzja->powrot = j;
				decyzja->sytuacja = sytuacja;
				//decyzja->skrzynka.y = sytuacja.skrzynie[n].y+1;
				for (k=0; k<skrzynek; k++)
					for (l=0; l<5; l++)
						decyzja->kierunki[k][l] = kierunki[k][l];
						
						
				pierwszy.sytuacja = sytuacja;
				pierwszy.sytuacja.skrzynie[n].y++;
				wyznacz_kierunki(&pierwszy);
				pierwszy.sytuacja.skrzynie[n].y--;
				
				for (k=0; k<skrzynek; k++)
					for (l=0; l<4; l++)
						kierunki[k][l] = pierwszy.kierunki[k][l];

				decyzja->n=n;
				if (poz_docelowe[sytuacja.skrzynie[n].x][sytuacja.skrzynie[n].y+1]=='x')// {
					n = (n + 1) % skrzynek;
				push(decyzja);
				sytuacja = sytuacja_glob;
				
				goto nowa_proba;
			}
			if (kierunki[n][j]==LEWO && (plansza_tmp[sytuacja.skrzynie[n].x-1][sytuacja.skrzynie[n].y]==' ' || plansza_tmp[sytuacja.skrzynie[n].x-1][sytuacja.skrzynie[n].y]=='.')&& plansza_tmp[sytuacja.skrzynie[n].x+1][sytuacja.skrzynie[n].y]=='.' && bloki[sytuacja.skrzynie[n].x-1][sytuacja.skrzynie[n].y]!='.' && !rog(sytuacja.skrzynie[n].x-1, sytuacja.skrzynie[n].y, sytuacja.skrzynie[n].x, sytuacja.skrzynie[n].y)) {
				// sproboj w lewo
				#ifdef debug
				printf("moze w lewo...\n");
				#endif
					
				decyzja = malloc(sizeof(struct ruch));
				decyzja->sokoban.x = sytuacja.skrzynie[n].x+1;
				decyzja->sokoban.y = sytuacja.skrzynie[n].y;
				decyzja->skrzynka.x = sytuacja.skrzynie[n].x;
				decyzja->skrzynka.y = sytuacja.skrzynie[n].y;
				for (x=0; x<maxx; x++)
					for(y=0; y<maxy; y++)
						plansza_tmp2[x][y]=plansza[x][y];
		
				for (x=0; x<skrzynek; x++)
					plansza_tmp2[sytuacja.skrzynie[x].x][sytuacja.skrzynie[x].y]='O';
				
					
				plansza_tmp2[decyzja->skrzynka.x-1][decyzja->skrzynka.y]='O';
				
				wyznacz_pole_dzialania(plansza_tmp2, 1, 1, 1, 1, decyzja->skrzynka.x, decyzja->skrzynka.y);
				
				// znalezienie odp pozycji sokobana do zapamietania w stanie
				
				for (x=0; x<maxx; x++)
					for(y=0; y<maxy; y++)
						if (plansza_tmp2[x][y] == '.')
							goto koniec3;
							
				koniec3:
				
				sytuacja_glob.sokoban.x = x;
				sytuacja_glob.sokoban.y = y;
				
				// pozycje skrzynek
				
				for (x=0; x<skrzynek; x++) {
					sytuacja_glob.skrzynie[x].x = sytuacja.skrzynie[x].x;
					sytuacja_glob.skrzynie[x].y = sytuacja.skrzynie[x].y;
				}
				
				sytuacja_glob.skrzynie[n].x--;
				
				decyzja->i = i;
				decyzja->plansza = plansza_tmp;
				decyzja->powrot = j;
				decyzja->sytuacja = sytuacja;
				for (k=0; k<skrzynek; k++)
					for (l=0; l<5; l++)
						decyzja->kierunki[k][l] = kierunki[k][l];
						
				pierwszy.sytuacja = sytuacja;
				pierwszy.sytuacja.skrzynie[n].x--;
				wyznacz_kierunki(&pierwszy);
				pierwszy.sytuacja.skrzynie[n].x++;
				
				for (k=0; k<skrzynek; k++)
					for (l=0; l<4; l++)
						kierunki[k][l] = pierwszy.kierunki[k][l];
				decyzja->n=n;
				if (poz_docelowe[sytuacja.skrzynie[n].x-1][sytuacja.skrzynie[n].y]=='x')// {
					n = (n + 1) % skrzynek;
				push(decyzja);
				sytuacja = sytuacja_glob;
				
				goto nowa_proba;
			}
			if (kierunki[n][j]==GORA && (plansza_tmp[sytuacja.skrzynie[n].x][sytuacja.skrzynie[n].y-1]==' ' || plansza_tmp[sytuacja.skrzynie[n].x][sytuacja.skrzynie[n].y-1]=='.')&& plansza_tmp[sytuacja.skrzynie[n].x][sytuacja.skrzynie[n].y+1]=='.' && bloki[sytuacja.skrzynie[n].x][sytuacja.skrzynie[n].y-1]!='.' && !rog(sytuacja.skrzynie[n].x, sytuacja.skrzynie[n].y-1, sytuacja.skrzynie[n].x, sytuacja.skrzynie[n].y)) {
				// sproboj w gore
				#ifdef debug
				printf("moze w gore...\n");
				#endif
				decyzja = malloc(sizeof(struct ruch));
				decyzja->sokoban.x = sytuacja.skrzynie[n].x;
				decyzja->sokoban.y = sytuacja.skrzynie[n].y+1;
				decyzja->skrzynka.x = sytuacja.skrzynie[n].x;
				decyzja->skrzynka.y = sytuacja.skrzynie[n].y;
				
				for (x=0; x<maxx; x++)
					for(y=0; y<maxy; y++)
						plansza_tmp2[x][y]=plansza[x][y];
		
				for (x=0; x<skrzynek; x++)
					plansza_tmp2[sytuacja.skrzynie[x].x][sytuacja.skrzynie[x].y]='O';
				
					
				plansza_tmp2[decyzja->skrzynka.x][decyzja->skrzynka.y-1]='O';
				
				wyznacz_pole_dzialania(plansza_tmp2, 1, 1, 1, 1, decyzja->skrzynka.x, decyzja->skrzynka.y);
				
				// znalezienie odp pozycji sokobana do zapamietania w stanie
				
				for (x=0; x<maxx; x++)
					for(y=0; y<maxy; y++)
						if (plansza_tmp2[x][y] == '.')
							goto koniec4;
							
				koniec4:
				
				sytuacja_glob.sokoban.x = x;
				sytuacja_glob.sokoban.y = y;
				
				// pozycje skrzynek
				
				for (x=0; x<skrzynek; x++) {
					sytuacja_glob.skrzynie[x].x = sytuacja.skrzynie[x].x;
					sytuacja_glob.skrzynie[x].y = sytuacja.skrzynie[x].y;
				}
				
				sytuacja_glob.skrzynie[n].y--;
				
				decyzja->i = i;
				decyzja->plansza = plansza_tmp;
				decyzja->powrot = j;
				decyzja->sytuacja = sytuacja;
				for (k=0; k<skrzynek; k++)
					for (l=0; l<4; l++)
						decyzja->kierunki[k][l] = kierunki[k][l];
						
						
				pierwszy.sytuacja = sytuacja;
				pierwszy.sytuacja.skrzynie[n].y--;
				wyznacz_kierunki(&pierwszy);
				pierwszy.sytuacja.skrzynie[n].y++;
				
				for (k=0; k<skrzynek; k++)
					for (l=0; l<4; l++)
						kierunki[k][l] = pierwszy.kierunki[k][l];
				decyzja->n=n;
				if (poz_docelowe[sytuacja.skrzynie[n].x][sytuacja.skrzynie[n].y-1]=='x')
					n = (n + 1) % skrzynek;

				push(decyzja);
				sytuacja = sytuacja_glob;
				
				goto nowa_proba;
			}
		}
	}
	#ifdef debug
	printf("cofam...\n");
	#endif

	x = 0;
	for (y=0; y<skrzynek; y++)
		if (poz_docelowe[sytuacja.skrzynie[y].x][sytuacja.skrzynie[y].y]=='x')
			x++;
	
			
	
	if (x==skrzynek) {
		#ifdef debug
		printf(":)\n");
		#endif
		koniec_zabawy();
	}

		
	pop();
	
	goto powrot;
	
}

void wypelnij(int sx, int sy, int dx, int dy) {
	if (sx==dx) {
		if (sy<dy)
			while (sy != dy) {
				bloki[dx][dy] = bloki[dx][dy] == '.' ? '.' : ',';
				dy--;
			}
		else {
			while (sy != dy) {
				bloki[dx][dy] = bloki[dx][dy] == '.' ? '.' : ',';
				dy++;
			}
		}
	} else {
		if (sx<dx)
			while (sx != dx) {
				bloki[dx][dy] = bloki[dx][dy] == '.' ? '.' : ',';
				dx--;
			}
		else {
			while (sx != dx) {
				bloki[dx][dy] = bloki[dx][dy] == '.' ? '.' : ',';
				dx++;
			}
		}
	}
}


void eliminacja() {
	int x, y, xx, yy;
	
	for (y=1; y<maxy-1; y++)
		for(x=1; x<maxx-1; x++)
			if (poz_docelowe[x][y]!='x' &&\
			    bloki[x][y]!='#' &&\
			    ((bloki[x][y-1]=='#' && bloki[x+1][y]=='#') ||\
			     (bloki[x+1][y]=='#' && bloki[x][y+1]=='#') ||\
			     (bloki[x][y+1]=='#' && bloki[x-1][y]=='#') ||\
			     (bloki[x-1][y]=='#' && bloki[x][y-1]=='#')))
				bloki[x][y]='.';
	
	for (y=1; y<maxy-1; y++)
		for(x=1; x<maxx-1; x++)
			if (bloki[x][y]=='.') {
				yy = y;
				while (bloki[x][yy]!='#' && bloki[x+1][yy]=='#' && poz_docelowe[x][yy]!='x')
					yy--;
					
				if (bloki[x][yy]=='#')
					wypelnij(x, y, x, yy+1);
					
					
				yy = y;
				while (bloki[x][yy]!='#' && bloki[x-1][yy]=='#' && poz_docelowe[x][yy]!='x')
					yy++;
					
				if (bloki[x][yy]=='#')
					wypelnij(x, y, x, yy-1);
				
					
					
				xx = x;
				while (bloki[xx][y]!='#' && bloki[xx][y+1]=='#' && poz_docelowe[xx][y]!='x')
					xx++;
					
				if (bloki[xx][y]=='#')
					wypelnij(x, y, xx-1, y);
				
				
					
				xx = x;
				while (bloki[xx][y]!='#' && bloki[xx][y-1]=='#' && poz_docelowe[xx][y]!='x')
					xx--;
					
				if (bloki[xx][y]=='#')
					wypelnij(x, y, xx+1, y);
			}
			
	for (y=0; y<maxy; y++)
		for(x=0; x<maxx; x++)
			bloki[x][y] = bloki[x][y] == ',' ? '.' : bloki[x][y];

}

int main() {
    	int plik;
    	char znak;
    	int x=0, y=0;
    	int i=0, j, k;
    	char buf[1000];
    	int bylo = 0;
	int** tablica;
	char przypisane[maxskrz];
	int min = 0;
    
	
	while ((znak = getchar())!=EOF) {
		if (znak=='\r')
			continue;
		buf[i++]=znak;
		x++;
		if (znak=='\n') {
	    		x = 0;
	    		maxy++;
		}
		
		if (x>maxx)
			maxx = x;
	}
	buf[i]=0;
    
    
	
    x = y = 0;
    
    plansza = malloc(maxx*sizeof(char*));
    plansza_tmp2 = malloc(maxx*sizeof(char*));
    plansza_blok = malloc(maxx*sizeof(char*));
    bloki = malloc(maxx*sizeof(char*));
    poz_docelowe = malloc(maxx*sizeof(char*));
    
    for (i=0; i<maxx; i++) {
    	plansza[i] = malloc(maxy*sizeof(char));
	plansza_tmp2[i] = malloc(maxy*sizeof(char));
	plansza_blok[i] = malloc(maxy*sizeof(char));
	bloki[i] = malloc(maxy*sizeof(char));
	poz_docelowe[i] = malloc(maxy*sizeof(char));
	memset(poz_docelowe[i], ' ', maxy);
	memset(bloki[i], ' ', maxy);
    }
    
    i = j = k = 0;

	while (buf[i]!=0) {
		if (buf[i]=='\n') {
			bylo = 0;
			while (k<maxx) {
				plansza[k][j]='#';
				k++;
			}
			j++;
			k=0;
			i++;
			continue;
		}
		
		if (bylo)
			plansza[k][j] = ' ';
		else
			plansza[k][j] = '#';

		if (buf[i]=='x') {
			mdocel[docel].x = k;
			mdocel[docel++].y = j; // m. docelowe
			poz_docelowe[k][j] = 'x';
		} else if (buf[i]=='X') {
			stanpocz.sokoban.x = k;
	    		stanpocz.sokoban.y = j;
	    		start.x = k;
	    		start.y = j;
			mdocel[docel].x = k;
			mdocel[docel++].y = j; // m. docelowe
			poz_docelowe[k][j] = 'x';
		} else if (buf[i]=='O') {
			stanpocz.skrzynie[skrzynek].x = k;
			stanpocz.skrzynie[skrzynek++].y = j;
		} else if (buf[i]=='@') {
			stanpocz.skrzynie[skrzynek].x = k;
			stanpocz.skrzynie[skrzynek++].y = j;
			mdocel[docel].x = k;
			mdocel[docel++].y = j; // m. docelowe
		
			poz_docelowe[k][j] = 'x';
		} else if (buf[i]=='*') {
			stanpocz.sokoban.x = k;
	    		stanpocz.sokoban.y = j;
	    		start.x = k;
	    		start.y = j;
		} else {
			if (buf[i] == '#')
				bylo = 1;
				
			plansza[k][j] = bylo ? buf[i] : '#';
		}
			
		k++;
		i++;
	}

	if (skrzynek>10)
		n=2;
	
	qsort(mdocel, skrzynek, sizeof(struct pozycja), compar);
	qsort(stanpocz.skrzynie, skrzynek, sizeof(struct pozycja), compar);
	
	//tablice kosztow
   	for(i=0; i<skrzynek; i++) {
		koszty[i] = malloc(maxx*sizeof(int*));
		for (j=0; j<maxx; j++)
    			koszty[i][j] = malloc(maxy*sizeof(int));
   	}


	tablica = malloc(maxx*sizeof(int*));
    	    
    	for (i=0; i<maxx; i++)
    		tablica[i] = malloc(maxy*sizeof(int));

	bzero(przypisane, skrzynek);
		
	for (i=0; i<skrzynek; i++) {
		for (x=0; x<maxx; x++)
			for(y=0; y<maxy; y++)
				tablica[x][y] = plansza[x][y]==' ' ? 99999 : -1;
		tablica[mdocel[i].x][mdocel[i].y] = 1;
		szukaj_drogi(tablica, mdocel[i].x, mdocel[i].y, 0);
		for (j=0;;j++)
			if (przypisane[j]==0) {
				min=j;
				break;
			}
		for (j=min+1; j<skrzynek; j++)
			if (tablica[stanpocz.skrzynie[j].x][stanpocz.skrzynie[j].y] < tablica[stanpocz.skrzynie[min].x][stanpocz.skrzynie[min].y] && przypisane[j]==0)
				min = j;
		
		przypisane[min]=i; // skrzynce min przypisuje miejsce docelowe i
	}
	
	for (i=0; i<skrzynek; i++) {
		for (x=0; x<maxx; x++)
			for(y=0; y<maxy; y++)
				koszty[i][x][y] = plansza[x][y]==' ' ? 99999 : -1;
		koszty[i][mdocel[przypisane[i]].x][mdocel[przypisane[i]].y] = 1;
		szukaj_drogi(koszty[i], mdocel[przypisane[i]].x, mdocel[przypisane[i]].y, 0);
	}
	
	
	
	//bloki
	for (x=0; x<maxx; x++)
		for(y=0; y<maxy; y++)
			bloki[x][y]=plansza[x][y];

	eliminacja();
			
    //posortuj mdocel
    
    
    
// wyznaczenie tymczasowej planszy dla nowego stanu
	for (x=0; x<maxx; x++)
		for(y=0; y<maxy; y++)
			plansza_tmp2[x][y]=plansza[x][y];
	
	for (x=0; x<skrzynek; x++)
		plansza_tmp2[stanpocz.skrzynie[x].x][stanpocz.skrzynie[x].y]='x';
			
	wyznacz_pole_dzialania(plansza_tmp2, 1, 1, 1, 1, stanpocz.sokoban.x, stanpocz.sokoban.y);
	
			
			// znalezienie odp pozycji sokobana do zapamietania w stanie
			
	for (x=0; x<maxx; x++)
		for(y=0; y<maxy; y++)
			if (plansza_tmp2[x][y] == '.')
				goto koniec;
				
	koniec:	
			
	stanpocz.sokoban.x = x;
	stanpocz.sokoban.y = y;
			

			// posortowanie skrzynek

	
			

	sytuacja = stanpocz;
	pierwszy.sytuacja = sytuacja;
	
	wyznacz_kierunki(&pierwszy);
	
    	rozwiazuj();
    
	return EXIT_SUCCESS;
}
